

;//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
; //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
;
; NC-MAX : Tool zur bertragung von CNC-Programmen ber die serielle Schnittstelle zu CNC-Maschinen.
;
; Author  : Alexander Diaconu
; Email   : adiaconu@web.de
;
; PB      : 4.60
; Datum   : 17.02.2012
;
; Copyright by Alexander Diaconu
; 
; History:
;
; 0.817 -> StopBit(Float-Bug)entfernt, vergessenes UnlockMutex hinzugefgt
;          Mann kann jetzt zusehen, wie das Programm in der Vorschau eingelesen wird
;          Whrend einer bertragung kann nicht mehr irrtmlich auf Programm laden
;          oder auf bertragungsrichtung ndern oder auf Maschine wechseln geklickt werden.
;          Der Name der aktuellen Maschine wird jetzt im 2.Reiter angezeigt.
;
;          Probleme beim Einlesen mit hohen Baudraten gefixed...
;
; 0.816 -> Hilfedatei hinzugefgt
;          viele kleinere Bugfixes...
;
; 0.815 -> Maschinenverwaltung hinzugefgt : Maschinen knnen angelegt und entfernt werden
;
; 0.814 -> rechter Klick auf den Button, der das Standardverzeichnis festlegt, wechselt zum festg. Standardordner 
;          Option fr den grsseren Font in der INI-Datei angelegt (BoldFont = 1 oder 0)
;          Dateiendung wird beim Speichern hinzugefgt, wenn nicht vorhanden
;          
;
; 0.813 -> sehr bsen Flchtigkeitsfehler gefixed. Ist quasi das 2. Sonntagsupdate :-)
; 
; 0.812 -> kleine Fehler bereinigt (Speicherfunktion auch), bei mir am PC luft alles, mal schaun wie's in der Praxis aussieht :-) 
;
; 0.811 -> ReadFromMachine berarbeitet (Threadsafe gemacht mit LockMutex)
;          SendToMaschine leicht verndert (Senden von PC -> CNC bitte auch nochmal neu ausprobieren....)
;
; 0.810 -> Debug-Version 
;                                  
; 0.809 -> Bug fixed in "ReadFromMachine" (WindowEvent), Versionsanzeige hinzugefgt
; 0.808 -> neue GUI implementiert, AutoSave & Timouts eingefgt
; 0.807 -> Umschaltknopf gendert, aktuelles Verzeichnis anzeigen, Spaltenbreite ExplorerList angepasst
;
;
; //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
; //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


Global Version.f = 0.817
Global Mutex = CreateMutex()
Global DevMode = 0

;{ ///// ENUMERATION Start //////////

;:PureFORM:Init:Start:
Enumeration
  #Window
EndEnumeration
Enumeration
  #StatusBar_Window
EndEnumeration
Enumeration
  #Button_78
  #Image_79
  #Image_80
  #ProgressBar_81
  #Frame3D_84
  #PanelGadget
  #String_105
  #CheckBox_98
  #String_93
  #Text_75
  #ComboBox_69
  #String_63
  #ExplorerList_62
  #Editor_88
  #String_77
  #Frame3D_76
  #Button_85
  #Button_82
  #String_71
  #String_51
  #Text_48
  #Text_47
  #Text_46
  #Text_45
  #Text_44
  #Text_43
  #Text_41
  #Text_40
  #Text_39
  #Text_38
  #Text_37
  #Text_36
  #Text_35
  #Text_34
  #Text_32
  #Text_21
  #Text_20
  #Text_19
  #Text_18
  #Text_17
  #Text_16
  #Frame3D_27
  #ComboBox_15
  #ComboBox_22
  #ComboBox_23
  #ComboBox_24
  #ComboBox_25
  #ComboBox_28
  #Frame3D_29
  #Frame3D_30
  #Frame3D_31
  #String_52
  #ComboBox_54
  #String_55
  #ComboBox_58
  #ComboBox_62
  #ComboBox_65
  #ComboBox_66
  #ComboBox_67
  #String_68
  #String_69
  #String_70
  #Editor_73
  #String_64
  #Frame3D_68
  #ButtonImage_70
  #ButtonImage_71
  #String_76
  #Text_77
  #String_78
  #ComboBox_79
  #ComboBox_80
  #Text_82
  #Button_89
  #Text_97
  #Text_103
  #ButtonImage_104
  #Container
EndEnumeration
Enumeration
  #Image_Image_79
  #Image_Image_80
  #Image_ButtonImage_65
  #Image_ButtonImage_66
EndEnumeration
;:PureFORM:Init:End:

DataSection
  Image_Image_79:
  IncludeBinary "E:\PureProjekte\ncmax\pc.ico"
  Image_Image_80:
  IncludeBinary "E:\PureProjekte\ncmax\zahnrad.ico"
  Image_ButtonImage_65:
  IncludeBinary "E:\PureProjekte\ncmax\send.ico"
  Image_ButtonImage_66:
  IncludeBinary "E:\PureProjekte\ncmax\read.ico"
EndDataSection

CatchImage(#Image_Image_79, ?Image_Image_79)
CatchImage(#Image_Image_80, ?Image_Image_80)

CatchImage(#Image_ButtonImage_65, ?Image_ButtonImage_65)
CatchImage(#Image_ButtonImage_66, ?Image_ButtonImage_66)

;CatchImage(#Help_Icon, ?Help_Icon)

;} ///// ENUMERATION Ende //////////


; ///// Variablendeklaration /////////
Global.l Event, EventWindow, EventGadget, EventType, EventMenu
Global programdata.s, param.s, preference.s, PrefPath.s, QuitThread = 0
Global Overwrite.b, OldStatusBar

Global port ; nur fr XON/XOFF Testsenden

Prototype.l GetModuleFileNameEx(hProcess.l, hModule.l, *lpFilename, nSize)
Prototype.l EnumProcessModules(hProcess, *lphModule, cb, lpchNeeded)
Prototype.l GetProcessImageFileName(hProcess.l,*lpImageFileName,nSize)


Declare OpenWindow_Window()
Declare FindPreference()
Declare FillComboBoxes()
Declare WritePreference(b.b)
Declare LoadPreferences()
Declare PortError(Error)
Declare AddControlChars()
Declare SendToMachine(d)
Declare SendToMachine2(d)
Declare ReadFromMachine(d)
Declare ReadFromMachine2(d)
Declare FindListItem(GadgetID.w,Expression.l,fMode.b=0,Column.b=0,iStart.l=0)
Declare LoadProgram()
Declare SaveProgram()
Declare ToggleMachine()
Declare AddMachine()
Declare DelMachine()
Declare.b OverwriteFile()
Declare.b ProgramExists(name.s)
Declare EnumWindows(hWnd)
Declare OpenWith()
Declare ButtonProc(hWnd, msg, wparam, lparam)
Declare ButtonProc2(hWnd, msg, wparam, lparam)
Declare SubClassedStatusBar(hwnd, msg, wParam, lParam)
Declare.l LoWord (var.l)
Declare ReceiveCopyData(hWnd, msg, wparam, lparam)
Declare ShowHelp()
Declare ErrorHandler()


;:PureFORM:Windows:Start:
;:PureFORM:Window_0_1:Start:
Procedure OpenWindow_Window()
  
 If Not OpenWindow(#Window, 670, 166, 667, 734, "NC-Max", #PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered|#PB_Window_TitleBar) : RaiseError(7) : EndIf
 
 ;nur frs Testsenden von XON/XOFF
 ;AddKeyboardShortcut(#Window, #PB_Shortcut_F1,15)
 ;AddKeyboardShortcut(#Window, #PB_Shortcut_F2,16)
 
 ;gewnschten Font laden
 FindPreference() : OpenPreferences(preference.s)
 If Val(ReadPreferenceString("BoldFont", "0")) = 1
 LoadFont(0,"System",4);,#PB_Font_Bold)
 SetGadgetFont(#PB_Default, FontID(0))
 EndIf : ClosePreferences()

 StatusBar = CreateStatusBar(#StatusBar_Window, WindowID(#Window))
 AddStatusBarField(85)
 AddStatusBarField(#PB_Ignore)
 AddStatusBarField(40)
 StatusBarText(#StatusBar_Window, 0, " Version " + StrF(Version,3));,#PB_StatusBar_Right);#PB_StatusBar_BorderLess); #PB_StatusBar_Raised) 
 StatusBarText(#StatusBar_Window, 2, "Hilfe", #PB_StatusBar_Center) 

 ;StatusBarImage(#StatusBar_Window, 2, ImageID(#Help_Icon),#PB_StatusBar_Center | #PB_StatusBar_Raised)
 OldStatusBar = SetWindowLong_(StatusBar, #GWL_WNDPROC, @SubclassedStatusBar())
 
 
 ;Panel Senden & Empfangen
 PanelGadget(#PanelGadget, 15, 14, 639, 596)
 AddGadgetItem(#PanelGadget, -1, "Senden/Empfangen")
  StringGadget(#String_93, 31, 45, 498, 23, "Gadget_93", #PB_String_ReadOnly)
  StringGadget(#String_105, 533, 45, 34, 23, "*.nc", #ES_CENTER)
  ButtonGadget(#ButtonImage_104, 570, 44, 25, 25, ":\")
  ExplorerListGadget(#ExplorerList_62, 31, 77, 564, 317, "", #PB_Explorer_AlwaysShowSelection|#PB_Explorer_FullRowSelect|#PB_Explorer_GridLines)
  ButtonGadget(#Button_85, 31, 414, 120, 27, "Programm laden")
  StringGadget(#String_77, 164, 417, 370, 22, "", #WS_BORDER)
  ButtonImageGadget(#Button_89, 546, 407, 51, 43, ImageID(#Image_ButtonImage_65))
  EditorGadget(#Editor_88, 12, 478, 602, 76, #PB_Editor_ReadOnly)
  Frame3DGadget(#Frame3D_76, 11, 16, 602, 447, " Programm auswhlen ")
 
 ;Panel COM-Einstellungen 
 AddGadgetItem(#PanelGadget, -1, "COM1")
  ComboBoxGadget(#ComboBox_69, 29, 40, 209, 21)
  ButtonGadget(#ButtonImage_70, 249, 39, 21, 23, "+")
  ButtonGadget(#ButtonImage_71, 274, 39, 21, 23, "-")
  ComboBoxGadget(#ComboBox_22, 458, 41, 123, 21)
  ComboBoxGadget(#ComboBox_15, 458, 68, 123, 21)
  ComboBoxGadget(#ComboBox_23, 458, 95, 123, 21)
  ComboBoxGadget(#ComboBox_54, 458, 122, 123, 21)
  ComboBoxGadget(#ComboBox_25, 458, 149, 123, 21)
  ComboBoxGadget(#ComboBox_28, 458, 176, 123, 21)
  StringGadget(#String_51, 199, 108, 65, 21, "300", #PB_String_Numeric)
  ComboBoxGadget(#ComboBox_24, 199, 135, 65, 21)
  ComboBoxGadget(#ComboBox_62, 199, 162, 65, 21)
  StringGadget(#String_55, 199, 189, 65, 21, "04",#PB_String_Numeric)
  StringGadget(#String_71, 194, 253, 65, 20, "300", #PB_String_Numeric)
  ComboBoxGadget(#ComboBox_66, 194, 279, 65, 21)
  ComboBoxGadget(#ComboBox_58, 194, 305, 65, 21) : DisableGadget(#ComboBox_58, 1)
  ComboBoxGadget(#ComboBox_67, 194, 331, 65, 21)
  ComboBoxGadget(#ComboBox_65, 194, 357, 65, 21)
  StringGadget(#String_63, 487, 250, 95, 21, "", #PB_String_Numeric)
  StringGadget(#String_64, 487, 277, 95, 21, "", #PB_String_Numeric)
  StringGadget(#String_52, 487, 304, 95, 21, "")
  StringGadget(#String_68, 487, 331, 95, 21, "")
  StringGadget(#String_69, 487, 358, 95, 21, "")
  StringGadget(#String_70, 487, 385, 95, 21, "")
  StringGadget(#String_76, 107, 460, 53, 21, "",#PB_String_Numeric)
  StringGadget(#String_78, 107, 486, 53, 21, "",#PB_String_Numeric)
  ComboBoxGadget(#ComboBox_80, 250, 459, 52, 21) : DisableGadget(#ComboBox_80, 1)
  ComboBoxGadget(#ComboBox_79, 250, 486, 52, 21) : DisableGadget(#ComboBox_79, 1)
  CheckBoxGadget(#CheckBox_98, 321, 486, 73, 21, "DTR/DSR", #PB_CheckBox_Right)
  ButtonGadget(#Button_82, 474, 474, 139, 38, "Einstellungen speichern")
  TextGadget(#Text_75, 34, 460, 69, 21, "XOn-Zeichen", #SS_CENTERIMAGE)
  TextGadget(#Text_48, 299, 386, 182, 21, "Stringausgabe nach Zeilenende", #SS_CENTERIMAGE)
  TextGadget(#Text_47, 299, 359, 182, 21, "Stringausgabe nach (M02/M30)", #SS_CENTERIMAGE)
  TextGadget(#Text_46, 299, 332, 182, 21, "Stringausgabe nach Programmende", #SS_CENTERIMAGE)
  TextGadget(#Text_45, 299, 304, 182, 21, "Stringausgabe vor Programmbeginn", #SS_CENTERIMAGE)
  TextGadget(#Text_44, 299, 278, 182, 21, "Anzahl HEX(00) Zeichen als Nachlauf", #SS_CENTERIMAGE)
  TextGadget(#Text_43, 299, 251, 182, 21, "Anzahl HEX(00) Zeichen als Vorlauf", #SS_CENTERIMAGE)
  TextGadget(#Text_41, 31, 357, 154, 21, "[%] Zeichen ausfiltern", #SS_CENTERIMAGE)
  TextGadget(#Text_40, 31, 331, 154, 21, "St.Zeichen Hex(00-1F) ausfiltern", #SS_CENTERIMAGE)
  TextGadget(#Text_39, 31, 279, 154, 21, "Puffergrsse", #SS_CENTERIMAGE)
  TextGadget(#Text_38, 31, 305, 154, 21, "Zeilenumbruch", #SS_CENTERIMAGE)
  TextGadget(#Text_37, 31, 253, 154, 21, "TimeOut", #SS_CENTERIMAGE)
  TextGadget(#Text_36, 35, 162, 154, 21, "St.ZeichenHex (00-1F) ausfiltern", #SS_CENTERIMAGE)
  TextGadget(#Text_35, 35, 189, 154, 21, "Einlesen Beenden mit Zeichen", #SS_CENTERIMAGE)
  TextGadget(#Text_34, 35, 135, 154, 21, "Puffergrsse", #SS_CENTERIMAGE)
  TextGadget(#Text_32, 35, 108, 154, 21, "TimeOut", #SS_CENTERIMAGE)
  TextGadget(#Text_21, 344, 176, 95, 21, "Handshake", #SS_CENTERIMAGE)
  TextGadget(#Text_20, 344, 149, 95, 21, "Stopbits", #SS_CENTERIMAGE)
  TextGadget(#Text_19, 344, 122, 95, 21, "Paritt", #SS_CENTERIMAGE)
  TextGadget(#Text_18, 344, 95, 95, 21, "Datenbits", #SS_CENTERIMAGE)
  TextGadget(#Text_17, 344, 68, 95, 21, "Baudrate", #SS_CENTERIMAGE)
  TextGadget(#Text_16, 344, 41, 95, 21, "COM-Nummer", #SS_CENTERIMAGE)
  Frame3DGadget(#Frame3D_27, 324, 16, 289, 207, " bertragung ")
  Frame3DGadget(#Frame3D_29, 17, 85, 288, 138, " Empfangen ")
  Frame3DGadget(#Frame3D_30, 16, 228, 598, 200, " Senden ")
  Frame3DGadget(#Frame3D_31, 16, 437, 441, 86, " XON/XOFF ")
  Frame3DGadget(#Frame3D_68, 17, 16, 289, 62, " Maschine ")
  TextGadget(#Text_77, 34, 487, 69, 21, "XOff-Zeichen", #SS_CENTERIMAGE)
  TextGadget(#Text_82, 171, 460, 69, 21, "XOn senden", #SS_CENTERIMAGE) 
  TextGadget(#Text_97, 171, 486, 69, 21, "XOn warten", #SS_CENTERIMAGE) 

  TextGadget(#Text_103, 321, 461, 97, 21, "DTR/DSR nutzen:")
 
 ;CNC-Programm Panel
 AddGadgetItem(#PanelGadget, -1, "CNC-Programm")
  EditorGadget(#Editor_73, 24, 22, 583, 520, #PB_Editor_ReadOnly)
  CloseGadgetList()
 
;  SetWindowColor(#Window, $E6E6E6) 
;  ContainerGadget(#Container, 15, 623, 638, 72,#PB_Container_Single);#PB_Container_Double);#PB_Container_Single);#PB_Container_Flat);#PB_Container_Raised)
;  ;SetGadgetColor(#Container, #PB_Gadget_BackColor, $449D25)
;  CloseGadgetList()
  
 ButtonGadget(#Button_78, 35, 640, 149, 38, "bertragung starten")
 ImageGadget(#Image_79, 215, 642, 32, 32, CatchImage(#Image_Image_79, ?Image_Image_79))
 ImageGadget(#Image_80, 586, 642, 32, 32, CatchImage(#Image_Image_80, ?Image_Image_80))
 ProgressBarGadget(#ProgressBar_81, 257, 646, 318, 22, 0, 100)
 Frame3DGadget(#Frame3D_84, 15, 623, 638, 72, "", #PB_Frame3D_Double|#PB_Frame3D_Flat|#PB_Frame3D_Single)
 
 
 
 ;:PureFORM:Window_0_1:End:
 SetGadgetItemAttribute(#ExplorerList_62, 0, #PB_Explorer_ColumnWidth, 331,0)
 SetGadgetItemAttribute(#ExplorerList_62, 0, #PB_Explorer_ColumnWidth, 50,1)
 SetGadgetItemAttribute(#ExplorerList_62, 0, #PB_Explorer_ColumnWidth, 60,2)
 SetGadgetItemAttribute(#ExplorerList_62, 0, #PB_Explorer_ColumnWidth, 119,3)  
 ;:PureFORM:Window_0_2:Start:


EndProcedure
;:PureFORM:Window_0_2:End:
;:PureFORM:Windows:End:


;////////////////////////////// Programmprozeduren /////////////////////////////////////


Procedure FindPreference()
 
  Protected nProcID, nResult, nTemp, hProcess
  Protected sFile.s
  Dim lModules.l(200)
 
  Protected GetModuleFileNameEx.GetModuleFileNameEx
  Protected EnumProcessModules.EnumProcessModules
  Protected GetProcessImageFileName.GetProcessImageFileName

   If Not OpenLibrary(0, "psapi.dll") : RaiseError(7) : EndIf
   GetModuleFileNameEx = GetFunction(0, "GetModuleFileNameExA")
   EnumProcessModules = GetFunction(0, "EnumProcessModules")
   GetProcessImageFileName = GetFunction(0,"GetProcessImageFileNameA")
  

  If GetWindowThreadProcessId_(WindowID(#Window), @nProcID) <> 0
   hProcess = OpenProcess_(#PROCESS_QUERY_INFORMATION | #PROCESS_VM_READ, 0, nProcID)
    If hProcess <> 0
     nResult = EnumProcessModules(hProcess, @lModules(0), 200, @nTemp)
      If nResult <> 0
       sFile = Space(260)
       nResult = GetModuleFileNameEx(hProcess, 0, @sFile, Len(sFile))
       sFile = LCase(Left(sFile, nResult))    
      EndIf
    ;Handle schlieen
    CloseHandle_(hProcess)
    EndIf
  EndIf
  
  CloseLibrary(0)
  preference = GetPathPart(sFile) + "ncmax.ini"
  
EndProcedure


Procedure FillComboBoxes()
 
 ; ////////// Gadgets mit Einstellungen auffllen /////////////////////////////////////////////////////////////////////////////////////
 
 ;////////// Baudrate
 AddGadgetItem(#ComboBox_15, -1, "50")
 AddGadgetItem(#ComboBox_15, -1, "75")
 AddGadgetItem(#ComboBox_15, -1, "110")
 AddGadgetItem(#ComboBox_15, -1, "150")
 AddGadgetItem(#ComboBox_15, -1, "300")
 AddGadgetItem(#ComboBox_15, -1, "600")
 AddGadgetItem(#ComboBox_15, -1, "1200")
 AddGadgetItem(#ComboBox_15, -1, "1800")
 AddGadgetItem(#ComboBox_15, -1, "2400")
 AddGadgetItem(#ComboBox_15, -1, "4800")
 AddGadgetItem(#ComboBox_15, -1, "9600")
 AddGadgetItem(#ComboBox_15, -1, "19200")
 AddGadgetItem(#ComboBox_15, -1, "38400")
 AddGadgetItem(#ComboBox_15, -1, "57600")
 AddGadgetItem(#ComboBox_15, -1, "115200")
 
 ;////////// COM-Name
 AddGadgetItem(#ComboBox_22, -1, "COM1")
 AddGadgetItem(#ComboBox_22, -1, "COM2")
 AddGadgetItem(#ComboBox_22, -1, "COM3")
 
 ;////////// Datenbits
 AddGadgetItem(#ComboBox_23, -1, "7")
 AddGadgetItem(#ComboBox_23, -1, "8")
 
 ;////////// Paritt
 AddGadgetItem(#ComboBox_54, -1, "NOPARITY")
 AddGadgetItem(#ComboBox_54, -1, "EVENPARITY")
 AddGadgetItem(#ComboBox_54, -1, "MARKPARITY")
 AddGadgetItem(#ComboBox_54, -1, "ODDPARITY")
 AddGadgetItem(#ComboBox_54, -1, "SPACEPARITY")
 
 ;////////// Stopbit
 AddGadgetItem(#ComboBox_25, -1, "1")
 AddGadgetItem(#ComboBox_25, -1, "2")
 AddGadgetItem(#ComboBox_25, -1, "1.5")
 
 ;////////// Protokoll
 AddGadgetItem(#ComboBox_28, -1, "NOHANDSHAKE")
 AddGadgetItem(#ComboBox_28, -1, "RTSHANDSHAKE")
 AddGadgetItem(#ComboBox_28, -1, "RTS/CTS")
 AddGadgetItem(#ComboBox_28, -1, "XON/XOFF")
 
 
 ;////////// Einlesen Puffergrsse
 AddGadgetItem(#ComboBox_24, -1, "4096")
 
 ;////////// Einlesen Steuerzeichen ausfiltern
 AddGadgetItem(#ComboBox_62, -1, "Ja")
 AddGadgetItem(#ComboBox_62, -1, "Nein")
 
 ;////////// Ausgeben Linefeed
 AddGadgetItem(#ComboBox_58, -1, "LF")
 AddGadgetItem(#ComboBox_58, -1, "CR/LF")
 
 ;////////// Ausgeben Puffergrsse
 AddGadgetItem(#ComboBox_66, -1, "4096")
 
 
 ;////////// Ausgeben Prozentzeichen ausfiltern
 AddGadgetItem(#ComboBox_67, -1, "Ja")
 AddGadgetItem(#ComboBox_67, -1, "Nein")
 
 ;////////// Ausgeben Hex ausfiltern
 AddGadgetItem(#ComboBox_65, -1, "Ja")
 AddGadgetItem(#ComboBox_65, -1, "Nein")
 
 ;////////// XON/Xoff warten/senden 
 AddGadgetItem(#ComboBox_80, -1, "Ja")
 AddGadgetItem(#ComboBox_80, -1, "Nein")
 AddGadgetItem(#ComboBox_79, -1, "Ja") 
 AddGadgetItem(#ComboBox_79, -1, "Nein")
 
 ;Preference aktuelle Maschine und PrefPath lesen
 OpenPreferences(preference.s)
 maschine.s = ReadPreferenceString("Maschine","Fanuc10t")
 PrefPath = ReadPreferenceString("Path", "c:\")
 SetGadgetText(#String_105, ReadPreferenceString("Pattern", "*.nc"))
 
 ;ExplorerList und Zielzeile aktualisieren
 If Not param
 SetGadgetText(#ExplorerList_62, PrefPath + GetGadgetText(#String_105)) 
 SetGadgetText(#String_93,GetGadgetText(#ExplorerList_62)) 
 EndIf
 
 ;Maschinen in ComboBox laden
 ExaminePreferenceGroups()
 While NextPreferenceGroup()
  AddGadgetItem(#Combobox_69, -1, PreferenceGroupName())
 Wend
 
 ;aktuelle Maschine 
 SetGadgetText(#ComboBox_69, Maschine)
 ClosePreferences()
 
 ;Einstellungen laden
 LoadPreferences()
  
EndProcedure


Procedure WritePreference(b.b)
 
 ; ////////// INI schreiben /////////////////////////////////////////////////////////////////////////////////////

 OpenPreferences(preference.s)
 
 maschine.s = GetGadgetText(#ComboBox_69) : PreferenceGroup(maschine)
 
 If b : PreferenceComment("----------------------------------------------") : EndIf
 WritePreferenceString("Baudrate", GetGadgetText(#ComboBox_15))
 WritePreferenceString("COM-Nummer", GetGadgetText(#ComboBox_22))
 WritePreferenceString("Datenbits", GetGadgetText(#ComboBox_23))
 WritePreferenceString("Paritt", GetGadgetText(#ComboBox_54))
 WritePreferenceString("Stopbits", GetGadgetText(#ComboBox_25))
 WritePreferenceString("Protokoll", GetGadgetText(#ComboBox_28))
 
 WritePreferenceString("TimeOut_Empfangen", GetGadgetText(#String_51))
 WritePreferenceString("Puffergrsse_Empfangen", GetGadgetText(#ComboBox_24))
 WritePreferenceString("Steuerzeichen_Empfangen", GetGadgetText(#ComboBox_62))
 WritePreferenceString("EinlesenBeenden_Empfangen", GetGadgetText(#String_55))
 
 WritePreferenceString("TimeOut_Senden", GetGadgetText(#String_71))
 WritePreferenceString("Zeilenumbruch_Senden", GetGadgetText(#ComboBox_58))
 WritePreferenceString("Puffergrsse_Senden", GetGadgetText(#ComboBox_66))
 WritePreferenceString("Steuerzeichen_Senden", GetGadgetText(#ComboBox_65))
 WritePreferenceString("Prozent_Filtern_Senden", GetGadgetText(#ComboBox_67))
 
 WritePreferenceString("Anzahl_Hexzeichen_Vorlauf", GetGadgetText(#String_63))
 WritePreferenceString("Anzahl_Hexzeichen_Nachlauf", GetGadgetText(#String_64))
 WritePreferenceString("Stringausgabe_Beginn", GetGadgetText(#String_52))
 WritePreferenceString("Stringausgabe_Ende", GetGadgetText(#String_68))
 WritePreferenceString("Stringausgabe_(M02/M30)", GetGadgetText(#String_69))
 WritePreferenceString("Stringausgabe_nach_Zeilenende", GetGadgetText(#String_70))
 
 WritePreferenceString("XON", GetGadgetText(#String_76))
 WritePreferenceString("XOFF", GetGadgetText(#String_78))
 WritePreferenceString("XON_Senden", GetGadgetText(#ComboBox_80))
 WritePreferenceString("XON_Warten", GetGadgetText(#ComboBox_79))
 
 If GetGadgetState(#CheckBox_98) = #PB_Checkbox_Checked : WritePreferenceString("DTR/DSR", "Ja") : Else : WritePreferenceString("DTR/DSR", "Nein") : EndIf
 If b : PreferenceComment("----------------------------------------------") : EndIf
 
 ClosePreferences()
 
EndProcedure


Procedure LoadPreferences()

  
; ////////// INI lesen /////////////////////////////////////////////////////////////////////////////////////
 
 OpenPreferences(preference.s)
 
 maschine.s = ReadPreferenceString("Maschine","Fanuc10t")
 PrefPath = ReadPreferenceString("Path", "c:\")
 SetGadgetText(#String_105, ReadPreferenceString("Pattern", "*.nc"))
 SetGadgetItemText(#PanelGadget, 1, maschine.s)
 
 PreferenceGroup(maschine)
 ;SetGadgetText(#ComboBox_22, ReadPreferenceString("COM-Nummer", "COM1"))
 SetGadgetText(#ComboBox_15, ReadPreferenceString("Baudrate", "4800"))
 SetGadgetText(#ComboBox_23, ReadPreferenceString("Datenbits", "8"))
 SetGadgetText(#ComboBox_54, ReadPreferenceString("Paritt", "NOPARITY"))
 SetGadgetText(#ComboBox_25, ReadPreferenceString("Stopbits", "1"))
 SetGadgetText(#ComboBox_28, ReadPreferenceString("Protokoll", "NOHANDSHAKE"))
 
 SetGadgetText(#String_51, ReadPreferenceString("TimeOut_Empfangen", "300"))
 ;SetGadgetText(#ComboBox_24, ReadPreferenceString("Puffergrsse_Empfangen", "4096"))
 SetGadgetText(#ComboBox_62, ReadPreferenceString("Steuerzeichen_Empfangen", "Nein"))
 SetGadgetText(#String_55, ReadPreferenceString("EinlesenBeenden_Empfangen", "04"))
 
 SetGadgetText(#String_71, ReadPreferenceString("TimeOut_Senden", "300"))
 ;SetGadgetText(#ComboBox_66, ReadPreferenceString("Puffergrsse_Senden", "4096"))
 SetGadgetText(#ComboBox_58, ReadPreferenceString("Zeilenumbruch_Senden", "LF"))
 SetGadgetText(#ComboBox_65, ReadPreferenceString("Steuerzeichen_Senden", "Nein"))
 SetGadgetText(#ComboBox_67, ReadPreferenceString("Prozent_Filtern_Senden", "Nein"))
 
 SetGadgetText(#String_63, ReadPreferenceString("Anzahl_Hexzeichen_Vorlauf", "0"))
 SetGadgetText(#String_64, ReadPreferenceString("Anzahl_Hexzeichen_Nachlauf", "0"))
 SetGadgetText(#String_52, ReadPreferenceString("Stringausgabe_Beginn", ""))
 SetGadgetText(#String_68, ReadPreferenceString("Stringausgabe_Ende", ""))
 SetGadgetText(#String_69, ReadPreferenceString("Stringausgabe_(M02/M30)", ""))
 SetGadgetText(#String_70, ReadPreferenceString("Stringausgabe_nach_Zeilenende", ""))
 
 SetGadgetText(#String_76, ReadPreferenceString("XON", "17"))
 SetGadgetText(#String_78, ReadPreferenceString("XOFF", "19"))
 SetGadgetText(#ComboBox_80, ReadPreferenceString("XON_Senden", "Ja"))
 SetGadgetText(#ComboBox_79, ReadPreferenceString("XON_Warten", "Ja"))
 
 If ReadPreferenceString("DTR/DSR","Nein") = "Ja" : SetGadgetState(#CheckBox_98,#PB_Checkbox_Checked) : Else : SetGadgetState(#CheckBox_98,#PB_Checkbox_Unchecked) : EndIf
 
 ;Einstellungen fr COM-PORT
 k = #False
 com.s = ReadPreferenceString("COM-Nummer", "COM1")
 For i = 1 To CountGadgetItems(#ComboBox_22)
  If com.s = GetGadgetItemText(#ComboBox_22, i-1)
   SetGadgetText(#ComboBox_22, com.s)
   k = #True
   Break
  EndIf
 Next i 
 If k = #False
  AddGadgetItem(#ComboBox_22, 0, com.s)
  SetGadgetText(#ComboBox_22, com.s)
 EndIf
 
  
 ;Einstellungen fr Puffergrsse (Empfangen)
 k = #False
 com.s = ReadPreferenceString("Puffergrsse_Empfangen", "4096")
 For i = 1 To CountGadgetItems(#ComboBox_24)
  If com.s = GetGadgetItemText(#ComboBox_24, i-1)
   SetGadgetText(#ComboBox_24, com.s)
   k = #True
   Break
  EndIf
 Next i 
 If k = #False
  AddGadgetItem(#ComboBox_24, 0, com.s)
  SetGadgetText(#ComboBox_24, com.s)
 EndIf
 
 ;Einstellungen fr Puffergrsse (Senden)
 k = #False
 com.s = ReadPreferenceString("Puffergrsse_Senden", "4096")
 For i = 1 To CountGadgetItems(#ComboBox_66)
  If com.s = GetGadgetItemText(#ComboBox_66, i-1)
   SetGadgetText(#ComboBox_66, com.s)
   k = #True
   Break
  EndIf
 Next i 
 If k = #False
  AddGadgetItem(#ComboBox_66, 0, com.s)
  SetGadgetText(#ComboBox_66, com.s)
 EndIf
 
 ClosePreferences()
 
EndProcedure


Procedure PortError(Error)

; ////////// Porterror ausgeben /////////////////////////////////////////////////////////////////////////////////////
 
 If Error & #PB_SerialPort_RxOver 
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_RxOver") : EndIf
 If Error & #PB_SerialPort_OverRun 
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_OverRun") : EndIf
 If Error & #PB_SerialPort_RxParity
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_RxParity") : EndIf
 If Error & #PB_SerialPort_Frame 
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_Frame") : EndIf
 If Error & #PB_SerialPort_Break
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_Break") : EndIf
 If Error & #PB_SerialPort_TxFull 
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_TxFull") : EndIf
 If Error & #PB_SerialPort_IOE 
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_IOE") : EndIf
 If Error & #PB_SerialPort_WaitingCTS
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_WaitingCTS") : EndIf
 If Error & #PB_SerialPort_WaitingDSR
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_WaitingDSR") : EndIf
 If Error & #PB_SerialPort_WaitingRLSD 
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_WaitingRLSD") : EndIf
 If Error & #PB_SerialPort_XoffReceived
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_XoffReceived") : EndIf
 If Error & #PB_SerialPort_XoffSent 
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_XoffSent") : EndIf
 If Error & #PB_SerialPort_EOFSent 
 AddGadgetItem(#Editor_88, -1, "bertragungsfehler !!! " + "#PB_SerialPort_EOFSent") : EndIf
 
  
EndProcedure


Procedure AddControlChars()
 
 
;  ; ////////// CR/LF einfgen //////////
;  If GetGadgetText(#ComboBox_58) = "CR/LF" 
;  programdata = ReplaceString(programdata, Chr(10), (Chr(13)+Chr(10)))
;  EndIf
 
 ; ////////// Prozentzeichen entfernen //////////
 If GetGadgetText(#ComboBox_65) = "Ja"
 programdata = RemoveString(programdata, "%")
 EndIf
 
 
  ; ////////// Steuerzeichen entfernen //////////
 If GetGadgetText(#ComboBox_67) = "Ja"
  For i = 0 To 31
  If (i <> 10) And (i <> 13) 
  programdata = RemoveString(programdata, Chr(i))
  EndIf
  Next i
 EndIf
 
 
 ;///////////////////////////// Stringausgabe nach Zeilenende /////////////////////////////
 ; eventuell noch nicht richtig, vielleicht so gedacht, dass ein String ZWISCHEN jeder Zeile eingefgt wird.
 ;/////////////////////////////////////////////////////////
 
 If GetGadgetText(#String_70)
  For i = 1 To Len(programdata)
   pos.s = Mid(programdata,i,1)
   If pos = Chr(10)
    mid.s = Mid(programdata, i-1,1)
    If mid = Chr(13)
    programdata = InsertString(programdata, GetGadgetText(#String_70),i-1)
    Else
    programdata = InsertString(programdata, GetGadgetText(#String_70),i)
    EndIf
    i + Len(GetGadgetText(#String_70))
   EndIf
  Next i
 EndIf
 
 
 ;////////////////////////////// Stringausgabe vor Programmbeginn //////////////////////////
 If GetGadgetText(#String_52)
 programdata = InsertString(programdata, GetGadgetText(#String_52) + Chr(10), 1)
 EndIf
 
 
 ;////////////////////////////// Stringausgabe vor Programmende //////////////////////////
 If GetGadgetText(#String_68)
 programdata = programdata + Chr(10) + GetGadgetText(#String_68) 
 EndIf
 
  
 ;////////////////////////////////// Stringausgabe nach M02/30 ////////////////////////////////
 If GetGadgetText(#String_69)
 If FindString(programdata, "M02",1) : programdata = InsertString(programdata, GetGadgetText(#String_69), FindString(programdata, "M02",1) + 3) : EndIf
 If FindString(programdata, "M30",1) : programdata = InsertString(programdata, GetGadgetText(#String_69), FindString(programdata, "M30",1) + 3) : EndIf
 EndIf
 
EndProcedure


Procedure SendToMachine(d)
 
 ; ////////// CNC-Programm an Maschine senden /////////////////////////////////////////////////////////////////////////////////////
 
 Define StopBits.f
 If GetGadgetText(#String_77) = "" : ProcedureReturn : EndIf
 
 LockMutex(Mutex) 
 
 *mem = AllocateMemory(1024) : If Not *mem : RaiseError(8) : EndIf
 
 ; ////////// COM-Einstellungen aus Gadgets lesen ///////////
 
 Baud = Val(GetGadgetText(#ComboBox_15))
 Com.s = GetGadgetText(#ComboBox_22) : If DevMode = 1 : Com.s = "CNCA0" : EndIf
 DataBits = Val(GetGadgetText(#ComboBox_23))
 StopBits = ValF(GetGadgetText(#ComboBox_25))
 InputBuffer = Val(GetGadgetText(#ComboBox_24))
 OutputBuffer = Val(GetGadgetText(#ComboBox_66))
 Debug StopBits
 Select GetGadgetText(#ComboBox_54)
 Case "NOPARITY"
 Parity = #PB_SerialPort_NoParity
 Case "EVENPARITY"
 Parity = #PB_SerialPort_EvenParity 
 Case "MARKPARITY"
 Parity = #PB_SerialPort_MarkParity 
 Case "ODDPARITY"
 Parity = #PB_SerialPort_OddParity 
 Case "SPACEPARITY"
 Parity = #PB_SerialPort_SpaceParity
 EndSelect
 
 Select GetGadgetText(#ComboBox_28)
 Case "NOHANDSHAKE"
 Handshake = #PB_SerialPort_NoHandshake
 Case "RTSHANDSHAKE"
 Handshake = #PB_SerialPort_RtsHandshake
 Case "RTS/CTS"
 Handshake = #PB_SerialPort_RtsCtsHandshake
 Case "XON/XOFF"
 Handshake = #PB_SerialPort_XonXoffHandshake
 EndSelect
 
 ;Xon / Xoff
 Xon  = Val(GetGadgetText(#String_76))
 Xoff = Val(GetGadgetText(#String_78))
 Select GetGadgetText(#ComboBox_80) : Case "Ja" : SendXon = #True : Case "Nein" : SendXon = #False  : EndSelect
 Select GetGadgetText(#ComboBox_79) : Case "Ja" : WaitXon = #True : Case "Nein" : WaitXon = #False  : EndSelect
 

 ; ////////// Progressbar intialisieren //////////
 AddControlChars() 
 
 datalen = Len(programdata)
 SetGadgetAttribute(#ProgressBar_81, #PB_ProgressBar_Maximum, datalen)
 SetGadgetState(#ProgressBar_81, 0)
 
 ; ////////// Port ffnen //////////
 port = OpenSerialPort(#PB_Any, Com, Baud, Parity, DataBits, StopBits, Handshake, InputBuffer, OutputBuffer)
 
 If port <> 0
 AddGadgetItem(#Editor_88, -1, "serielle Schnittstelle geffnet ("+ Str(port)+")")
 Else
  AddGadgetItem(#Editor_88, -1, "Fehler! serielle Schnittstelle konnte nicht geffnet werden.")
  UnlockMutex(Mutex)
  ProcedureReturn
 EndIf 
 
 SerialPortTimeouts(port, 100, 100, 100, 10, Val(GetGadgetText(#String_71)))
 SetGadgetText(#Button_78, "Abbrechen")
 
;DTR-Signal senden und auf Antwort warten
 If GetGadgetState(#CheckBox_98) = #PB_Checkbox_Checked
 SetSerialPortStatus(port, #PB_SerialPort_DTR, 1)
 AddGadgetItem(#Editor_88, -1, "DTR-Signal (ON) gesendet. Warte auf Antwort...")
 While GetSerialPortStatus(port, #PB_SerialPort_DSR) = 0
 If QuitThread = 1
  AddGadgetItem(#Editor_88, -1, "bertragung vorzeitig abgebrochen.")
  SetGadgetText(#String_77, "")
  SetGadgetText(#Button_78, "bertragung starten")
  SetGadgetState(#ProgressBar_81, 0)
  SetSerialPortStatus(port, #PB_SerialPort_DTR, 0)
  CloseSerialPort(port)
  UnlockMutex(Mutex)
  ProcedureReturn
 EndIf
 Wend
 AddGadgetItem(#Editor_88, -1, "DSR-Signal (ON) empfangen.")
 EndIf
 
; ///////////////// RTS an Maschine senden //////////////////
 If (Handshake = #PB_SerialPort_RtsCtsHandshake) Or (Handshake = #PB_SerialPort_RtsHandshake)
  SetSerialPortStatus(port, #PB_SerialPort_RTS, 1)
  If Handshake = #PB_SerialPort_RtsCtsHandshake
  AddGadgetItem(#Editor_88, -1, "RTS an Maschine gesendet, warte auf Antwort...")
  ElseIf Handshake = #PB_SerialPort_RtsHandshake
  AddGadgetItem(#Editor_88, -1, "RTS an Maschine gesendet, sende Daten...")
  EndIf
 EndIf
 
 
 If Handshake = #PB_SerialPort_RtsCtsHandshake 
 
 ;/////////// auf Signal von Maschine warten mit Abbruchmglichkeit ////////////////////////
 While GetSerialPortStatus(port, #PB_SerialPort_CTS) = 0
 
 If QuitThread = 1
  AddGadgetItem(#Editor_88, -1, "bertragung vorzeitig abgebrochen.")
  SetGadgetText(#String_77, "")
  SetGadgetText(#Button_78, "bertragung starten")
  SetGadgetState(#ProgressBar_81, 0)
  SetSerialPortStatus(port, #PB_SerialPort_RTS, 0)
  CloseSerialPort(port)
  UnlockMutex(Mutex)
  ProcedureReturn
 EndIf
 
 Wend
 ;//////////// Signal erhalten... ///////////
 
 If CTS = 0 : AddGadgetItem(#Editor_88, -1, "CTS von Maschine erhalten. Daten werden bertragen...") : CTS = 1 : EndIf
 EndIf
 
 ;/////////// auf XON von Maschine warten mit Abbruchmglichkeit ////////////////////////
 ;{
;  If Handshake = #PB_SerialPort_XonXoffHandshake
;  If WaitXon = #True
;  AddGadgetItem(#Editor_88, -1, "...warte auf XON Anweisung...")
;  While Exit = #False
;   error = SerialPortError(port) 
;   If Error & #PB_SerialPort_XoffSent : Exit=#False : Else : Exit=#True : EndIf
;  
;   If QuitThread = 1
;    AddGadgetItem(#Editor_88, -1, "bertragung vorzeitig abgebrochen.")
;    SetGadgetText(#String_77, "")
;    SetGadgetText(#Button_78, "bertragung starten")
;    SetGadgetState(#ProgressBar_81, 0)
;    SetSerialPortStatus(port, #PB_SerialPort_RTS, 0)
;    CloseSerialPort(port)
;    UnlockMutex(Mutex)
;    ProcedureReturn
;   EndIf
;  
;  Wend
;  FreeMemory(*memr)
;  
;  ;//////////// Signal erhalten... ///////////
;  AddGadgetItem(#Editor_88, -1, "XON von Maschine erhalten. Daten werden bertragen...") 
;  
;  EndIf
;  
;  
;  ;XON senden, wenn SendXon = Ja
;  If SendXon = #True
;   PokeB(*mem, Xon) 
;   tick = WriteSerialPortData(port,*mem,1)
;   AddGadgetItem(#Editor_88, -1, "... XON Anweisung gesendet ...")
;  EndIf 
;  EndIf
  ;}
  
 
 
 ;////////////////////////////// Anzahl HEX(00) Vorlauf //////////////////////////
 ii = Val(GetGadgetText(#String_63))
 If ii > 0
 For i = 1 To ii : PokeB(*mem, 0) : WriteSerialPortData(port, *mem, 1) : Next i
 EndIf
 
 ;////////////////////// Sendeschleife ////////////////////////////////////////////////////
 
 For i = 1 To Len(programdata)
 
 Debug AvailableSerialPortOutput(port)
 
 ;/////////// Daten senden.... ////////////
 PokeA(*mem, Asc(Mid(programdata,i,1))) : tick = WriteSerialPortData(port,*mem,1) 

 ;////////// Auf Fehlermeldung prfen /////////
 If tick = 0
  Error = SerialPortError(port)
  If Not Error & #PB_SerialPort_XoffReceived
   AddGadgetItem(#Editor_88, -1, "SerialPortError beim " + Str(i) + ". Zeichen :")
   PortError(Error)
   AddGadgetItem(#Editor_88, -1, "Zeichen wird in 1 Sekunde erneut gesendet...")
   Delay(1000) : i - 1
  EndIf
  If Handshake = #PB_SerialPort_XonXoffHandshake
  If Error & #PB_SerialPort_XoffReceived
   If XOM2 = 0 : AddGadgetItem(#Editor_88, -1, "bertragung wird unterbrochen...(XOFF erhalten)") : XOM2 = 1 : XOM = 0 : EndIf
    SendMessage_(GadgetID(#Editor_88), #EM_SETSEL,-1,-1)  
    i - 1 : Continue
  EndIf
  EndIf
 Else
  Bytes + tick 
  SetGadgetState(#ProgressBar_81, i)
  If Handshake = #PB_SerialPort_XonXoffHandshake
  If XOM = 0 : AddGadgetItem(#Editor_88, -1, "bertragung wird fortgesetzt...(XON erhalten)") : XOM = 1 : XOM2 = 0 : EndIf
  SendMessage_(GadgetID(#Editor_88), #EM_SETSEL,-1,-1)  
  EndIf
 EndIf
 
  ;///////////// Auf Abbruch des Anwenders prfen ///////////
  If QuitThread = 1
   AddGadgetItem(#Editor_88, -1, "bertragung vorzeitig abgebrochen.")
   SetGadgetText(#Button_78, "bertragung starten")
   SetGadgetText(#String_77, "")
   SetSerialPortStatus(port, #PB_SerialPort_RTS, 0)
   SetGadgetState(#ProgressBar_81, 0)
   CloseSerialPort(port)
   SendMessage_(GadgetID(#Editor_88), #EM_SETSEL,-1,-1)  
   UnlockMutex(Mutex)
   ProcedureReturn  
  EndIf
   
;  ; Empfang wurde vorzeitig abgebrochen (leider buggy)
;  If GetSerialPortStatus(port, #PB_SerialPort_CTS) = 0
;   AddGadgetItem(#Editor_88, -1, "bertragung wurde vorzeitig beendet. " + Str(Bytes)+ " Bytes gesendet.")
;   SetGadgetText(#Button_78, "bertragung starten")
;   SetGadgetText(#String_77, "")
;   SetGadgetState(#ProgressBar_81, 0)
;   CloseSerialPort(port)
;   UnlockMutex(Mutex)
;   ProcedureReturn
;  EndIf
 
 ;EditorGadget fr Messages automatisch nach unten scrollen
 SendMessage_(GadgetID(#Editor_88), #EM_SETSEL,-1,-1)  
  
 Next i ;///////////// Schleifenende ////////////////////
 
 
 ;////////////////////////////// Anzahl HEX(00) Nachlauf //////////////////////////
 ii = Val(GetGadgetText(#String_64))
 If ii > 0
 For i = 1 To ii : PokeB(*mem, 0) : WriteSerialPortData(port, *mem, 1) : Next i
 EndIf
 
 ;//////////// bertragung abschliessen, Port schliessen ////////////
 
 ;EOF senden
 PokeA(*mem, Val(GetGadgetText(#String_55))) : WriteSerialPortData(port, *mem, 1)
  
 ;DTR-Signal (OFF) senden
 If GetGadgetState(#CheckBox_98) = #PB_Checkbox_Checked
 SetSerialPortStatus(port, #PB_SerialPort_DTR, 0)
 AddGadgetItem(#Editor_88, -1, "DTR-Signal (OFF) gesendet.")
 EndIf
 
 CloseSerialPort(port)
  
 AddGadgetItem(#Editor_88, -1, "bertragung beendet. " + Str(Bytes)+ " Bytes gesendet.")
 SetGadgetText(#Button_78, "bertragung starten")
 SetGadgetText(#String_77, "")
 
 ;EditorGadget fr Messages automatisch nach unten scrollen
  SendMessage_(GadgetID(#Editor_88), #EM_SETSEL,-1,-1)  
   
 ;//////////// Ende der Prozedur ////////////////////////
 FreeMemory(*mem)
 
 UnlockMutex(Mutex)
 
EndProcedure


Procedure SendToMachine2(d)

EndProcedure


Procedure ReadFromMachine(d)

; ////////// CNC-Programm von Maschine auslesen /////////////////////////////////////////////////////////////////////////////////////

Define StopBits.f
Overwrite = OverwriteFile() 
If Overwrite = -2 : ProcedureReturn : EndIf
LockMutex(Mutex)
 
 
 ; ////////// COM-Einstellungen aus Gadgets lesen ///////////
 
 Baud = Val(GetGadgetText(#ComboBox_15))
 Com.s = GetGadgetText(#ComboBox_22) : If DevMode = 1 : Com.s = "CNCB0" : EndIf
 DataBits = Val(GetGadgetText(#ComboBox_23))
 StopBits = ValF(GetGadgetText(#ComboBox_25))
 InputBuffer = Val(GetGadgetText(#ComboBox_24))
 OutputBuffer = Val(GetGadgetText(#ComboBox_66))
 
 Select GetGadgetText(#ComboBox_54)
  Case "NOPARITY"
  Parity = #PB_SerialPort_NoParity
  Case "EVENPARITY"
  Parity = #PB_SerialPort_EvenParity 
  Case "MARKPARITY"
  Parity = #PB_SerialPort_MarkParity 
  Case "ODDPARITY"
  Parity = #PB_SerialPort_OddParity 
  Case "SPACEPARITY"
  Parity = #PB_SerialPort_SpaceParity
 EndSelect
 
 Select GetGadgetText(#ComboBox_28)
  Case "NOHANDSHAKE"
  Handshake = #PB_SerialPort_NoHandshake
  Case "RTSHANDSHAKE"
  Handshake = #PB_SerialPort_RtsHandshake
  Case "RTS/CTS"
  Handshake = #PB_SerialPort_RtsCtsHandshake
  Case "XON/XOFF"
  Handshake = #PB_SerialPort_XonXoffHandshake
 EndSelect
 
 ;Xon / Xoff
 Xon  = Val(GetGadgetText(#String_76))
 Xoff = Val(GetGadgetText(#String_78))
 Select GetGadgetText(#ComboBox_80) : Case "Ja" : SendXon = #True : Case "Nein" : SendXon = #False  : EndSelect
 Select GetGadgetText(#ComboBox_79) : Case "Ja" : WaitXon = #True : Case "Nein" : WaitXon = #False  : EndSelect
 
 
 ; ////////// Progressbar intialisieren //////////
 SetGadgetAttribute(#ProgressBar_81, #PB_ProgressBar_Maximum, 100)
 ClearGadgetItems(#Editor_88)
 ClearGadgetItems(#Editor_73)
 programdata = Chr(0)
 
 ; ////////// Port ffnen /////////////////////////
 port = OpenSerialPort(#PB_Any, Com, Baud, Parity, DataBits, StopBits, Handshake, InputBuffer, OutputBuffer)
 If port <> 0
 AddGadgetItem(#Editor_88, -1, "serielle Schnittstelle geffnet ("+ Str(port)+")")
 Else
 AddGadgetItem(#Editor_88, -1, "Fehler! serielle Schnittstelle konnte nicht geffnet werden.")
 UnlockMutex(Mutex)
 ProcedureReturn
 EndIf
 
 ;///////////////////////////// SerialPort Timouts einstellen /////////////////////////////
 SerialPortTimeouts(port, Val(GetGadgetText(#String_51)), Val(GetGadgetText(#String_51)), 100, 10, 100)
 
 SetGadgetItemText(#PanelGadget, 2, " Lesevorgang...")
 SetGadgetText(#Button_78, "Abbrechen")
 
 ;auf DTR-Signal warten + antworten
 If GetGadgetState(#CheckBox_98) = #PB_Checkbox_Checked
 AddGadgetItem(#Editor_88, -1, "Warte auf DTR-Signal (ON).")
 While GetSerialPortStatus(port, #PB_SerialPort_DSR) = 0
 If QuitThread = 1
  AddGadgetItem(#Editor_88, -1, "bertragung vorzeitig abgebrochen.")
  SetGadgetText(#String_77, "")
  SetGadgetText(#Button_78, "bertragung starten")
  SetGadgetState(#ProgressBar_81, 0)
  SetGadgetItemText(#PanelGadget, 2, "CNC-Programm")
  CloseSerialPort(port)
  UnlockMutex(Mutex)
  ProcedureReturn
 EndIf
 Wend
 SetSerialPortStatus(port, #PB_SerialPort_DTR, 1)
 AddGadgetItem(#Editor_88, -1, "DTR-Signal (ON) empfangen. DSR-Signal (ON) gesendet.")
 EndIf
 
 ;/////////// auf Signal von Maschine warten mit Abbruchmglichkeit ////////////////////////
 
 If (Handshake = #PB_SerialPort_RtsCtsHandshake) Or (Handshake = #PB_SerialPort_RtsHandshake)
 
 AddGadgetItem(#Editor_88, -1, "Warte auf RTS-Signal von Maschine...")
 While GetSerialPortStatus(port, #PB_SerialPort_CTS) = 0
  If QuitThread = 1
  AddGadgetItem(#Editor_88, -1, "bertragung vorzeitig abgebrochen.")
  SetGadgetText(#Button_78, "bertragung starten")
  SetGadgetState(#ProgressBar_81, 0)
  SetSerialPortStatus(port, #PB_SerialPort_RTS, 0)
  SetGadgetItemText(#PanelGadget, 2, "CNC-Programm")
  CloseSerialPort(port)
  UnlockMutex(Mutex)
  ProcedureReturn
 EndIf
 Wend
 
 ;//////////// Signal erhalten... ///////////
 AddGadgetItem(#Editor_88, -1, "RTS von Maschine erhalten. Daten werden empfangen...") 
 If Handshake = #PB_SerialPort_RtsCtsHandshake : SetSerialPortStatus(port,#PB_SerialPort_RTS, 1) : EndIf
 
 EndIf
 
 
 ;/////////// auf XON von Maschine warten mit Abbruchmglichkeit ////////////////////////
 ;{
;  If Handshake = #PB_SerialPort_XonXoffHandshake
;  
;  ;XON senden, wenn SendXon = Ja
;  If SendXon = #True : *memr = AllocateMemory(1024) : PokeB(*memr, Xon) : tick = WriteSerialPortData(port,*memr,1) : Debug tick:Debug PeekB(*memr):FreeMemory(*memr)
;  AddGadgetItem(#Editor_88, -1, "... XON Anweisung gesendet ...")
;  EndIf 
;  
;  If WaitXon
;  
;  AddGadgetItem(#Editor_88, -1, "...warte auf XON Anweisung...")
;  
;  While Not Exit 
;   
;   Input = AvailableSerialPortInput(port) 
;   If Input
;   *memr = AllocateMemory(Input)
;   ReadSerialPortData(port, *memr, Input)
;   If PeekB(*memr) = Xon : Exit = #True : EndIf
;   FreeMemory(*memr)
;   EndIf
;   
;   If QuitThread = 1
;    AddGadgetItem(#Editor_88, -1, "bertragung vorzeitig abgebrochen.")
;    SetGadgetText(#String_77, "")
;    SetGadgetText(#Button_78, "bertragung starten")
;    SetGadgetState(#ProgressBar_81, 0)
;    SetSerialPortStatus(port, #PB_SerialPort_RTS, 0)
;    CloseSerialPort(port)
;    UnlockMutex(Mutex)
;    ProcedureReturn
;   EndIf
;  
;  Wend
;  ;//////////// Signal erhalten... ///////////
;  AddGadgetItem(#Editor_88, -1, "XON von Maschine erhalten. Daten werden empfangen...") : Waiting = #False
;  
;  EndIf
;  EndIf
 ;XON Ende
 ;}
 
 
;////////// Sendeschleife //////////
 Repeat 
  
 ;///////// Inputbuffer prfen /////////
 Input = AvailableSerialPortInput(port) 
 SetGadgetState(#ProgressBar_81, 0)
 
 If Input > 0 
 
 ;//////////// Datenlesen + Auf Error prfen
  *mem = AllocateMemory(Input+1024) : If Not *mem : RaiseError(8) : EndIf
  tick = ReadSerialPortData(port, *mem, Input)
  
  ;///////// Error bearbeiten ////////////
  If tick = 0 
   Error = SerialPortError(port)
   If Error = #PB_SerialPort_EOFSent : finish = 2 : FreeMemory(*mem) : Break : EndIf
   If Not Error & #PB_SerialPort_XoffReceived
   AddGadgetItem(#Editor_88, -1, "SerialPortError beim " + Str(i) + ". Zeichen :") 
   PortError(Error)
   EndIf
   If Handshake = #PB_SerialPort_XonXoffHandshake
   If Error & #PB_SerialPort_XoffReceived
   If XOM2 = 0 : AddGadgetItem(#Editor_88, -1, "bertragung wird unterbrochen...(XOFF erhalten)") : XOM2 = 1 : XOM = 0 : EndIf
   EndIf
   EndIf
  Else
   ;///////// Zeichen einlesen /////////////
   Dim MyArray.b(Input-1) : nul = 1 : dat.s = Chr(0)
   For i = 0 To Input-1
    MyArray(i) = PeekB(*mem + i)
    If MyArray(i) = 0
     Nul = 0
    Else
     dat.s + Chr(MyArray(i))
    EndIf
   Next i
   pos1 = FindString(dat.s, Chr(Val(GetGadgetText(#String_55))))
   If pos1 > 0 
    rest.s = Mid(dat.s,1,pos1-1)
    Bytes = Bytes + Len(rest.s)
    programdata + rest.s
    SetGadgetItemText(#Editor_73, g+1, rest.s)
    finish = 1 : FreeMemory(*mem) : Break 
   Else
    Debug input
    programdata = programdata + dat.s
    Bytes = Bytes + Len(dat.s)
    SetGadgetItemText(#Editor_73, g, dat.s) : g + Len(dat.s)
    SendMessage_(GadgetID(#Editor_73), #EM_SETSEL,-1,-1)  
    If Nul = 0
     SetGadgetItemText(#Editor_88, -1, "HEX(00) Vorlauf / Nachlauf")
    Else
     SetGadgetItemText(#Editor_88, -1, Str(Bytes)+ " Bytes empfangen.")
    EndIf
    If Handshake = #PB_SerialPort_XonXoffHandshake
    If XOM = 0 : AddGadgetItem(#Editor_88, -1, "bertragung wird fortgesetzt...(XON erhalten)") : XOM = 1 : XOM2 = 0 : EndIf
    EndIf
   EndIf 
  EndIf
  FreeMemory(*mem)
 EndIf
   
 ;////////////// Auf Abbruch durch Anwender prfen ///////////////////////
 
 If QuitThread = 1
  AddGadgetItem(#Editor_88, -1, "bertragung vorzeitig abgebrochen.")
  SetGadgetText(#Button_78, "bertragung starten")
  SetSerialPortStatus(port, #PB_SerialPort_RTS, 0)
  SetGadgetState(#ProgressBar_81, 0)
  SetGadgetItemText(#PanelGadget, 2, "CNC-Programm")
  CloseSerialPort(port)
  UnlockMutex(Mutex)
  ProcedureReturn  
 EndIf
 
; Senden wurde vorzeitig abgebrochen (leider buggy)
;Debug GetSerialPortStatus(port, #PB_SerialPort_CTS)
;If GetSerialPortStatus(port, #PB_SerialPort_CTS) = 0 : Break : EndIf 
; If Quit = 600 : Break : EndIf

 
ForEver ;/////////////////// Schleifenende ///////////////////////////////// 



 ;////////////////// bertragung abschliessen  Port schliessen /////////
 ClearGadgetItems(#Editor_88)
 If Finish = 2
  AddGadgetItem(#Editor_88, -1, "Programmbertragung durch SerialPort(EOF) beendet.")
  AddGadgetItem(#Editor_88, -1, "bertragung erfolgreich abgeschlossen.")
 ElseIf Finish = 1
  AddGadgetItem(#Editor_88, -1, "Programmbertragung durch EOF<" + GetGadgetText(#String_55) + "> beendet.")
  AddGadgetItem(#Editor_88, -1, "bertragung erfolgreich abgeschlossen.")
 Else
  AddGadgetItem(#Editor_88, -1, "bertragung vorzeitig abgebrochen.")
 EndIf
 
 SetGadgetText(#Button_78, "bertragung starten")  
 SetSerialPortStatus(port,#PB_SerialPort_RTS, 0)
 
 ;DSR-Signal ausschalten
 If GetGadgetState(#CheckBox_98) = #PB_Checkbox_Checked
 SetSerialPortStatus(port, #PB_SerialPort_DTR, 0)
 AddGadgetItem(#Editor_88, -1, "DSR-Signal (OFF) gesendet.")
 EndIf
 
 AddGadgetItem(#Editor_88, -1, Str(Bytes)+ " Bytes empfangen.")
 CloseSerialPort(port)
 
 
 ; ////////// Steuerzeichen entfernen //////////
 If GetGadgetText(#ComboBox_62) = "Ja"
  For i = 1 To 31
  If Not (i = 10 Or i = 13) ; If Not (i = 10 Or i = 13)
  RemoveString(programdata, Chr(i))
  EndIf
  Next i
 EndIf
 
 ;ClearGadgetItems(#Editor_73)
 ;SetGadgetText(#Editor_73, programdata) 
 SetGadgetItemText(#PanelGadget, 2, "gelesenes Programm")
 
 ;EditorGadget fr Messages automatisch nach unten scrollen
  SendMessage_(GadgetID(#Editor_88), #EM_SETSEL,-1,-1)  
  SendMessage_(GadgetID(#Editor_73), #EM_SETSEL,0,0)
    
 ;AutoSave 
 If Finish = 1 Or Finish = 2
 SaveProgram()
 EndIf
 
 UnlockMutex(Mutex)
 ;/////////////////// Ende der Prozedur /////////////////////////////
 
EndProcedure


Procedure ReadFromMachine2(d)

 
EndProcedure


Procedure FindListItem(GadgetID.w,Expression.l,fMode.b=0,Column.b=0,iStart.l=0)
 
  Protected hwndListbox.l, Position.l, ItemCount.l, Length.l, i.l, Label.s
  Protected LVITEM.LV_ITEM
 
  If Not IsGadget(GadgetID) : ProcedureReturn -1 : EndIf
 
  hwndListbox = GadgetID(GadgetID) : Position = -1
 
  If fMode
    Position = Expression
  Else
    ItemCount = CountGadgetItems(GadgetID) - 1
   
    Length = lstrlen_(Expression)
   
    For i=iStart To ItemCount
      Label = GetGadgetItemText(GadgetID,i,Column)
     
      If CompareMemoryString(Expression,@Label,0,Length) = 0
        Position = i : Break
      EndIf
    Next
  EndIf
 
  SendMessage_(hwndListbox,#WM_VSCROLL,#SB_TOP,0)
  SendMessage_(hwndListbox,#LVM_ENSUREVISIBLE,Position,1)
 
  If Position > SendMessage_(hwndListbox,#LVM_GETCOUNTPERPAGE,0,0)-1
    SendMessage_(hwndListbox,#WM_VSCROLL,#SB_PAGEDOWN,0)
    SendMessage_(hwndListbox,#WM_VSCROLL,#SB_LINEUP,0)
  EndIf   
  
  LVITEM\mask = #LVIF_STATE   
  LVITEM\state = #LVIS_SELECTED 
  LVITEM\stateMask = #LVIS_SELECTED 
  SendMessage_(GadgetID(GadgetID), #LVM_SETITEMSTATE, Position, @LVITEM)
 
  SetActiveGadget(GadgetID)
  ProcedureReturn Position
  
EndProcedure


Procedure LoadProgram()

 ;////////////////// CNC-Programm ins EditorGadget laden ///////////////
 
 Index = GetGadgetState(#ExplorerList_62)
 If (GetGadgetItemState(#ExplorerList_62,Index) = #PB_Explorer_Directory | #PB_Explorer_Selected) Or (Index = -1)
 ProcedureReturn
 EndIf
 file.s = GetGadgetText(#ExplorerList_62) + GetGadgetItemText(#ExplorerList_62, Index)
 
 
 filepart.s = GetFilePart(file)
 SetGadgetText(#String_77, filepart)
 
 
 If ReadFile(0, file) 
  Length = Lof(0)                            
  *Mem = AllocateMemory(Length) : If Not *mem : RaiseError(8) : EndIf        
  If *Mem
   Bytes = ReadData(0, *Mem, Length)   
   EndIf
  CloseFile(0)
 EndIf

 programdata = PeekS(*Mem, Length) + Chr(0) : FreeMemory(*Mem)
 
 ClearGadgetItems(#Editor_73)
 ClearGadgetItems(#Editor_88)
 SetGadgetText(#Editor_73, programdata) 
 AddGadgetItem(#Editor_88,-1, "CNC-Programm geladen.")
 SetGadgetItemText(#PanelGadget, 2, filepart)
 
 
EndProcedure


Procedure ToggleMachine()
 
 maschine.s = GetGadgetText(#ComboBox_69)
 OpenPreferences(preference)
 WritePreferenceString("Maschine", maschine)
 ClosePreferences()
 LoadPreferences()
 
EndProcedure


Procedure AddMachine()

 ;Name fr Maschine / Steuerung auswhlen
 Maschine.s = InputRequester("Maschine hinzufgen", "Bitte geben Sie einen Namen fr die Maschine ein :","")
 If Maschine = "" : ProcedureReturn : EndIf
 
 ;Prfen, ob die Maschine bereits vorhanden ist...
 OpenPreferences(preference) 
 ExaminePreferenceGroups()
 While NextPreferenceGroup()
  If PreferenceGroupName() = Maschine
   MessageRequester("Maschine hinzufgen", "Diese Maschine ist bereits vorhanden. Bitte whlen Sie einen anderen Namen aus !")
   ClosePreferences() : ProcedureReturn
  EndIf
 Wend
 
 ;Maschinen in ComboBox laden
 AddGadgetItem(#Combobox_69, -1, Maschine)
 
 ;Machine zur aktuellen machen 
 ;WritePreferenceString("Machine", Maschine)
 SetGadgetText(#ComboBox_69, Maschine)
 SetGadgetItemText(#PanelGadget, 1, Maschine)
 
 ;Schlssel anlegen
 ClosePreferences()
 WritePreference(1)
 
EndProcedure


Procedure DelMachine()

If CountGadgetItems(#ComboBox_69) = 1 : MessageRequester("Maschine lschen", "Sie knnen die letzte Maschine nicht entfernen. Es muss immer eine Maschine vorhanden sein.") : ProcedureReturn : EndIf
If MessageRequester("Maschine lschen", "Mchten Sie die Maschine wirklich entfernen ?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_No : ProcedureReturn : EndIf

maschine.s = GetGadgetText(#ComboBox_69)
OpenPreferences(preference) 
RemovePreferenceGroup(maschine)
RemoveGadgetItem(#ComboBox_69,  GetGadgetState(#ComboBox_69))
ClosePreferences()
SetGadgetState(#ComboBox_69, 0)
ToggleMachine()

EndProcedure


Procedure.b OverwriteFile()

 file.s = GetGadgetText(#String_93)
 filepart.s = GetGadgetText(#String_77)
 If filepart.s = "" : ProcedureReturn -1 : EndIf
 file.s + filepart.s
 
 ;Dateiendung hinzufgen
 If GetExtensionPart(file.s) = "" : file.s + "." + GetExtensionPart(GetGadgetText(#String_105)) : EndIf
 
 If CheckFilename(GetFilePart(file.s)) = 0 : MessageRequester("NC-Max","Der Dateiname enthlt ungltige Zeichen !") : ProcedureReturn -2 : EndIf
 
 ;SetGadgetText(#String_77, GetFilePart(file.s))
 
 If FileSize(file) > -1 ; /////// Datei exsistiert bereits /////////
  Req = MessageRequester("Datei berschreiben ?","Die Datei " + Chr(34) + GetFilePart(file) + Chr(34) + " existiert bereits." + Chr(10) + "Mchten Sie die Datei wirklich berschreiben ?",#PB_MessageRequester_YesNo)
 
 If Req = #PB_MessageRequester_Yes
  ProcedureReturn 1
 Else
  ;SetGadgetText(#String_77, "")
  ProcedureReturn 0 
 EndIf  
 
 Else
  ProcedureReturn -1
 EndIf
 
EndProcedure

Procedure SaveProgram()
 
 
 ;////////////////// CNC-Programm vom EditorGadget speichern /////////////// 
 
 Index = GetGadgetState(#ExplorerList_62)
 If programdata = "" : ProcedureReturn : EndIf
 
  file.s = GetGadgetText(#String_93)
  filepart.s = GetGadgetText(#String_77)
  
  ;Falls ungltiger Dateiname abbrechen
  If filepart = "" Or Overwrite = -2 : ProcedureReturn : EndIf
  
  file + filepart 
  
  ;Dateiendung hinzufgen
  If GetExtensionPart(file) = "" : file + "." + GetExtensionPart(GetGadgetText(#String_105)) : EndIf
 
  ;Falls Overwrite = 1 Datei berschreiben
  If Overwrite = 1
   If CreateFile(0, file)   
   CloseFile(0)
   EndIf
  EndIf
  
  If Overwrite = 0 And FileSize(file) > -1 : ProcedureReturn : EndIf
   
  If OpenFile(0, file)   
   WriteData(0, @programdata, Len(programdata))
   CloseFile(0)
  EndIf 
    
; /////// Message aussgeben und ExplorerTree aktualisieren /////////
AddGadgetItem(#Editor_88, -1, "Programm unter "+ file + " gespeichert.")
SetGadgetItemText(#PanelGadget, 2, GetFilePart(file))
SetGadgetText(#ExplorerList_62, "*.nc") 

EndProcedure


Procedure.b ProgramExists(name.s)

;/////////////////////// Feststellen, ob das Programm bereits gestartet wurde /////////////////////////////////////////////////  
  CreateMutex_(0, 1, name)
  If (GetLastError_() = #ERROR_ALREADY_EXISTS)
  ProcedureReturn #True
  Else
  ProcedureReturn #False     
  EndIf
 
EndProcedure


Procedure EnumWindows(hWnd)

 ;/////////////////////// enumeriert vorhandene Fenster und sendet ein #WM_Close an die andere Instanz ///////////////////////////////  
 win$ = Space(1024)
 GetWindowText_(hWnd, win$, 1024)
 win$=RTrim(win$)
 If (win$ = "NC-Max") And (hWnd <> WindowID(#Window))
  CopyData.COPYDATASTRUCT
  CopyData\cbData = StringByteLength(param) + SizeOf(Character)
  CopyData\lpData = @param
  SendMessage_(hWnd, #WM_COPYDATA, WindowID(#Window), @CopyData)
  ProcedureReturn #False
 EndIf 
 ProcedureReturn #True


EndProcedure
 
 
Procedure OpenWith()

;//////////////////// "ffnen mit" //////////////////////////////////////////////////////////////////////////////////////////////
 
 param = ProgramParameter()

 If ProgramExists("NC-Max") = #False
  OpenWindow_Window()
  If Not param = ""
  Item.s = GetFilePart(param)
  SetGadgetText(#ExplorerList_62, GetPathPart(param) + "*." + GetExtensionPart(Item))
  FindListItem(#ExplorerList_62, @Item,0,0,0)
  SetGadgetText(#String_93,GetGadgetText(#ExplorerList_62))
  LoadProgram()
  EndIf
 Else
  EnumWindows_(@EnumWindows(), #Null)
  End
 EndIf
 
EndProcedure
 
  
Procedure ButtonProc(hWnd, msg, wparam, lparam)
 
 ;//////////////////////////////////////// Hookt den Switchbutton fr einen Rechtsklick /////////////////////////////////////
 oldproc = GetProp_(hWnd, "oldproc")
 gadget  = GetDlgCtrlID_(hWnd)
 Static dbl = #False ; boolean to filter following buttonup event on receiving doubleclick
 
 Select msg
  Case #WM_NCDESTROY
  RemoveProp_(hWnd, "oldproc")
  Case #WM_LBUTTONDBLCLK
  dbl=#True
  Case #WM_LBUTTONDOWN   
  Case #WM_RBUTTONDOWN
  ;/////////////////////////// Lscht das Messagefeld Editor_88 /////////////////////////////
  ClearGadgetItems(#Editor_88)
  Case #WM_LBUTTONUP
  If Not dbl
  Else
  dbl=#False ; ignore following buttonup event on finding doubleclick
  EndIf
  
 EndSelect
 
 ProcedureReturn CallWindowProc_(oldproc, hWnd, msg, wparam, lparam)
 
EndProcedure


Procedure ButtonProc2(hWnd, msg, wparam, lparam)
 
 ;//////////////////////////////////////// Hookt den Switchbutton fr einen Rechtsklick /////////////////////////////////////
 oldproc = GetProp_(hWnd, "oldproc")
 gadget  = GetDlgCtrlID_(hWnd)
 Static dbl = #False ; boolean to filter following buttonup event on receiving doubleclick
 
 Select msg
  Case #WM_NCDESTROY
  RemoveProp_(hWnd, "oldproc")
  Case #WM_LBUTTONDBLCLK
  dbl=#True
  Case #WM_LBUTTONDOWN   
  Case #WM_RBUTTONDOWN
  ;/////////////////////////// zum Standardverzeichnis wechseln /////////////////////////////
  SetGadgetText(#ExplorerList_62, PrefPath + "*." + GetExtensionPart(GetGadgetText(#String_105)))
  SetGadgetText(#String_93, PrefPath)
  Case #WM_LBUTTONUP
  If Not dbl
  Else
  dbl=#False ; ignore following buttonup event on finding doubleclick
  EndIf
  
 EndSelect
 
 ProcedureReturn CallWindowProc_(oldproc, hWnd, msg, wparam, lparam)
 
EndProcedure


Procedure.l  LoWord (var.l)
  ProcedureReturn var & $FFFF
EndProcedure


Procedure SubClassedStatusBar(hwnd, msg, wParam, lParam)
  result = CallWindowProc_(OldStatusBar, hwnd, msg, wparam, lparam)
  lParamLo = LoWord(lParam)
  Select msg
    Case #WM_LBUTTONDOWN
      If lParamLo > WindowWidth(#Window) - 40
        ShowHelp()
      EndIf
  EndSelect
  ProcedureReturn Result
EndProcedure


Procedure ReceiveCopyData(hWnd, msg, wparam, lparam)
 
 Protected *CopyData.COPYDATASTRUCT
 
 Select msg
  Case #WM_COPYDATA
   *CopyData.COPYDATASTRUCT = lparam
   param = "" : param = PeekS(*CopyData\lpData)
   If Not param = ""
   Item.s = GetFilePart(param)
     ;Falls beim "ffnen mit2 noch Programm speichern aktiv ist, auf Programm laden umschalten
     If GetGadgetText(#Button_85) = "Programm speichern"
      ;SetActiveGadget(#Frame3D_76)
      If GetGadgetAttribute(#Button_89, #PB_Button_Image) = ImageID(#Image_ButtonImage_65)
       SetGadgetAttribute(#Button_89, #PB_Button_Image, ImageID(#Image_ButtonImage_66))
       SetGadgetText(#Button_85,"Programm speichern")
       SetGadgetText(#String_77, "")
      Else
       SetGadgetAttribute(#Button_89, #PB_Button_Image, ImageID(#Image_ButtonImage_65))
       SetGadgetText(#Button_85,"Programm laden")
       SetGadgetText(#String_77, "")
     EndIf
     EndIf
     ;
   SetGadgetText(#ExplorerList_62, GetPathPart(param) + "*." + GetExtensionPart(Item))
   FindListItem(#ExplorerList_62, @Item,0,0,0)
   SetGadgetText(#String_93,GetGadgetText(#ExplorerList_62))
   SetGadgetText(#String_77, Item.s)
   LoadProgram()
   EndIf
  
  EndSelect 
 
 ProcedureReturn #PB_ProcessPureBasicEvents
 
EndProcedure 


Procedure ShowHelp()

OpenHelp("ncmax.chm","")

EndProcedure


Procedure ErrorHandler()
 
 ;//////////////////////////////////////// Errorhandler : gibt eine Fehlermeldung aus und beendet das Programm //////////////////////////////////
 
 If ErrorCode() = 8     : errormessage.s = "AllocateMemory fehlgeschlagen! "
 ElseIf ErrorCode() = 7 : errormessage.s = "Funktionsaufruf fehlgeschlagen! "
 Else : errormessage.s = ErrorMessage()
 EndIf
 
 MessageRequester("Programmfehler", errormessage + " Zeile: " +  Str(ErrorLine()))
 End
   
EndProcedure


;{
;:PureFORM:Gadgets:Start:
;:PureFORM:Gadgets:End:
;}


;///////////////////////////////////////////////////////// Programmbeginn ////////////////////////////////////////////////////////////////////

If DevMode = 0
OnErrorCall(@ErrorHandler())
OpenWith()
Else
OpenWindow_Window()
EndIf

FillComboBoxes()
;LoadPreferences()


;///////////////////////// CALLBACKS ///////////////////////////////////
;///////// Rechtsklick fr Button + Fenster enumerieren fr OpenWith
SetProp_(GadgetID(#Button_89), "oldproc", SetWindowLongPtr_(GadgetID(#Button_89), #GWL_WNDPROC, @ButtonProc()))
SetProp_(GadgetID(#ButtonImage_104), "oldproc", SetWindowLongPtr_(GadgetID(#ButtonImage_104), #GWL_WNDPROC, @ButtonProc2()))
SetWindowCallback(@ReceiveCopyData(),#Window)



;{ ///////////////////////////////////////////////////////// EVENTLOOP ////////////////////////////////////////////////////////////////////
;- EventLoop
  
Repeat
 
  Event  = WaitWindowEvent()
  EventGadget = EventGadget()
  EventType   = EventType() 
  
  If Event = #PB_Event_Menu
  ;If EventMenu() = 15 : Debug "XON" : *r = AllocateMemory(1024) : PokeB(*r, 17) : Debug WriteSerialPortData(port,*r, 1) : Debug SerialPortError(port): FreeMemory(*r) : EndIf
  ;If EventMenu() = 16 : Debug "XOFF" : *r = AllocateMemory(1024) : PokeB(*r, 19) : Debug WriteSerialPortData(port,*r, 1) : Debug SerialPortError(port):FreeMemory(*r) : EndIf
  EndIf     
   
  Select Event
    Case #PB_Event_Gadget
      Select EventGadget
        
         ;///// Dateifilter.... //////
        Case #String_77
        If EventType = #PB_EventType_Change
        SetGadgetText(#ExplorerList_62, GetPathPart(GetGadgetText(#ExplorerList_62)))
        SetGadgetText(#ExplorerList_62, GetPathPart(GetGadgetText(#ExplorerList_62))+ GetGadgetText(#String_77))
        EndIf
        
        ;//////// bertragung starten / Abrrechen ///////////////
        Case #Button_78
         If Not IsThread(Thread)
          QuitThread = 0 
           If GetGadgetAttribute(#Button_89, #PB_Button_Image) = ImageID(#Image_ButtonImage_65) 
            thread = CreateThread(@SendToMachine(), 22)
           Else
            thread = CreateThread(@ReadFromMachine(), 22)
           EndIf
         Else
          QuitThread = 1
        EndIf  
       
        ;//////// CNC-Programm laden / speichern ///////////////
        Case #Button_85
        If Not IsThread(thread)
        If GetGadgetText(#Button_85) = "Programm laden"
        LoadProgram()
        Else
        Overwrite = OverwriteFile()
        SaveProgram()
        EndIf
        EndIf
        
        ;//////// Umschaltknopf fr Senden/Empfangen //////////////
        Case #Button_89
        If Not IsThread(thread)
        ;SetActiveGadget(#Frame3D_76)
        If GetGadgetAttribute(#Button_89, #PB_Button_Image) = ImageID(#Image_ButtonImage_65)
        SetGadgetAttribute(#Button_89, #PB_Button_Image, ImageID(#Image_ButtonImage_66))
        SetGadgetText(#Button_85,"Programm speichern")
        SetGadgetText(#String_77, "")
        Else
        SetGadgetAttribute(#Button_89, #PB_Button_Image, ImageID(#Image_ButtonImage_65))
        SetGadgetText(#Button_85,"Programm laden")
        SetGadgetText(#String_77, "")
        EndIf
        EndIf
        
        ;////////// INI-Einstellungen speichern
        Case #Button_82
        WritePreference(0)
        
        Case #ExplorerList_62
        If Not IsThread(thread)
        SetGadgetText(#String_93,GetGadgetText(#ExplorerList_62))
        If EventType = #PB_EventType_Change And (GetGadgetAttribute(#Button_89, #PB_Button_Image) = ImageID(#Image_ButtonImage_66))
        Index = GetGadgetState(#ExplorerList_62)
        If GetGadgetItemState(#ExplorerList_62,Index) = #PB_Explorer_File | #PB_Explorer_Selected
        SetGadgetText(#String_77, GetGadgetItemText(#ExplorerList_62,Index))
        EndIf
        EndIf
        If EventType = #PB_EventType_LeftDoubleClick And (GetGadgetAttribute(#Button_89, #PB_Button_Image) = ImageID(#Image_ButtonImage_65))
        LoadProgram()
        EndIf
        EndIf
        
        Case #ButtonImage_104
        path$ = PathRequester("Bitte whlen sie das Standardverzeichnis fr ihre NC-Dateien aus:","c:\")
        If path$
        OpenPreferences(preference.s)
        WritePreferenceString("Path", path$)
        ClosePreferences()
        SetGadgetText(#ExplorerList_62, path$)
        SetGadgetText(#String_93, path$)
        PrefPath = path$
        EndIf
        
        Case #String_105
        If EventType = #PB_EventType_LostFocus
        OpenPreferences(preference.s) 
        WritePreferenceString("Pattern", GetGadgetText(#String_105))
        ClosePreferences()
        EndIf
        SetGadgetText(#ExplorerList_62, GetGadgetText(#ExplorerList_62) + GetGadgetText(#String_105)) 
        
        Case #ComboBox_69
        ToggleMachine()
        
        Case #ButtonImage_70
        AddMachine()
        
        Case #ButtonImage_71
        DelMachine()
        
        
        ;{ ////////////// unbenutze Gadgets ////////////////
        Case #Editor_88
        Case #Image_79
        Case #Image_80
        Case #ProgressBar_81
        Case #Frame3D_84
        Case #PanelGadget
        Case #Frame3D_76
        Case #String_71
        Case #String_51
        Case #Text_48
        Case #Text_47
        Case #Text_46
        Case #Text_45
        Case #Text_44
        Case #Text_43
        Case #Text_41
        Case #Text_40
        Case #Text_39
        Case #Text_38
        Case #Text_37
        Case #Text_36
        Case #Text_35
        Case #Text_34
        Case #Text_32
        Case #Text_21
        Case #Text_20
        Case #Text_19
        Case #Text_18
        Case #Text_17
        Case #Text_16
        Case #Frame3D_27
        Case #ComboBox_15
        Case #ComboBox_22
        Case #ComboBox_23
        Case #ComboBox_24
        Case #ComboBox_25
        Case #ComboBox_28
        Case #Frame3D_29
        Case #Frame3D_30
        Case #Frame3D_31
        Case #String_52
        Case #ComboBox_54
        Case #String_55
        Case #String_63
        Case #String_64
        Case #ComboBox_58
        Case #ComboBox_62
        Case #ComboBox_65
        Case #ComboBox_66
        Case #ComboBox_67
        Case #String_68
        Case #String_69
        Case #String_70
        Case #Editor_73
      EndSelect
      
      
    Case #PB_Event_CloseWindow
     Select EventWindow()
     Case #Window
     CloseWindow(#Window)
     Break
     EndSelect
  
 EndSelect
 

ForEver


;}



;{
;:PureFORM:AfterLoop:Start:
;:PureFORM:AfterLoop:End:
;}

End
;//////////// ENDE DES PROGRAMMS ////////////

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 184
; FirstLine = 157
; Folding = ---v
; EnableXP
; EnableOnError
; UseIcon = zahnrad.ico
; Executable = ncmax.exe
; CompileSourceDirectory
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 17
; Folding = -2----
; EnableThread
; EnableXP
; EnableOnError
; UseIcon = zahnrad.ico
; Executable = ncmax.exe
; CompileSourceDirectory
; Watchlist = programdata